# -*- coding:Utf-8 -*-
#-------------------------------------------------------------------------------
# Name:        script_mapcycle.py
#
# Author:      Nico
#
# Created:     03/12/2007
#-------------------------------------------------------------------------------

import es, os, re

info = es.AddonInfo()
info.name = "script_mapcycle"
info.version = "1.2"
info.author = "Nicolous"
info.url = "http://addons.eventscripts.com/addons/view/script_mapcycle"
info.description = "Generate a mapcycle from your maps/ directory"
info.tags = "mapcycle;maps"

es.ServerVar("mapcycle_version",info.version,info.name + " : Version of the MapCycle script").makepublic()

# If the script is activated
mapcycle_activation = es.ServerVar("mapcycle_activation","1",info.name + " : 1 = activation, 0 = off")

# File when the mapcycle will be generated
mapcycle_file = es.ServerVar("mapcycle_file","mapcycle.txt",info.name + " : File when the mapcycle will be generated")

# BSP map pattern
bsp_pattern = re.compile(".*\.bsp$").search

def getGameDir():
    """Return the game path, e.g. cstrike"""
    return es.getAddonPath(info.name).replace(os.sep,"/").replace("/addons/eventscripts/" + info.name,"")


def generateMapcyle(gameDir):
    """Generate the mapcycle file"""
    # Build the target directoty path
    pathFile = "%s/%s" % (gameDir,str(mapcycle_file))
    
    try:
        mapcycleFile = open(pathFile,"w")
            
        # Getting the files names of the maps/ directory
        maplist = os.listdir("%s/maps" % gameDir)

        # Force alphabetic order
        maplist.sort()

        # For all the .bsp file
        for fileName in filter(lambda fileName: bsp_pattern(fileName),maplist):
            mapcycleFile.write(os.path.splitext(fileName)[0])
            mapcycleFile.write("\n")
        
    except IOError, e:
        es.dbgmsg(0,"%s : Unable to write %s (%s)" %(info.name,pathFile,e.message))
    finally:
        if mapcycleFile is not None:
             mapcycleFile.close()

def es_map_start(event_var):
    # Immediatly execute the config file
    es.server.cmd("es_xmexec ../addons/eventscripts/script_mapcycle/configuration.txt")
    
    if int(mapcycle_activation) != 0:
        generateMapcyle(getGameDir())

